commit f741e787336452be2233c43ca02e6b363a46c6d4
Author: jklowden <jklowden>
Date:   Tue Nov 25 22:58:28 2008 +0000

    begin making unittests work with Microsoft's library

diff --git a/ChangeLog b/ChangeLog
index b7251a8..afbe251 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,25 +1,25 @@
 Mon Nov 17 19:46:34 EST 2008	JK Lowden <jklowden@freetds.org>
 	* src/dblib/dblib.c 
-	- src/dblib/bcp.c src/dblib/unittests/bcp.c
-	- src/dblib/unittests/common.c src/dblib/unittests/common.h
-	- src/dblib/unittests/dbmorecmds.c
-	- src/dblib/unittests/hang.c src/dblib/unittests/null.c
-	- src/dblib/unittests/null2.c src/dblib/unittests/rpc.c
-	- src/dblib/unittests/setnull.c
-	- src/dblib/unittests/t0001.c src/dblib/unittests/t0002.c
-	- src/dblib/unittests/t0003.c src/dblib/unittests/t0004.c
-	- src/dblib/unittests/t0005.c src/dblib/unittests/t0006.c
-	- src/dblib/unittests/t0007.c src/dblib/unittests/t0008.c
-	- src/dblib/unittests/t0009.c src/dblib/unittests/t0011.c 
-	- src/dblib/unittests/t0012.c src/dblib/unittests/t0013.c
-	- src/dblib/unittests/t0014.c src/dblib/unittests/t0015.c
-	- src/dblib/unittests/t0016.c src/dblib/unittests/t0018.c
-	- src/dblib/unittests/t0020.c src/dblib/unittests/t0021.c
-	- src/dblib/unittests/t0022.c src/dblib/unittests/t0023.c
-	- src/dblib/unittests/text_buffer.c
-	- src/dblib/unittests/thread.c
-	- src/dblib/unittests/timeout.c
-	- win32/tds_sysdep_public.h
+	* src/dblib/bcp.c src/dblib/unittests/bcp.c
+	* src/dblib/unittests/common.c src/dblib/unittests/common.h
+	* src/dblib/unittests/dbmorecmds.c
+	* src/dblib/unittests/hang.c src/dblib/unittests/null.c
+	* src/dblib/unittests/null2.c src/dblib/unittests/rpc.c
+	* src/dblib/unittests/setnull.c
+	* src/dblib/unittests/t0001.c src/dblib/unittests/t0002.c
+	* src/dblib/unittests/t0003.c src/dblib/unittests/t0004.c
+	* src/dblib/unittests/t0005.c src/dblib/unittests/t0006.c
+	* src/dblib/unittests/t0007.c src/dblib/unittests/t0008.c
+	* src/dblib/unittests/t0009.c src/dblib/unittests/t0011.c 
+	* src/dblib/unittests/t0012.c src/dblib/unittests/t0013.c
+	* src/dblib/unittests/t0014.c src/dblib/unittests/t0015.c
+	* src/dblib/unittests/t0016.c src/dblib/unittests/t0018.c
+	* src/dblib/unittests/t0020.c src/dblib/unittests/t0021.c
+	* src/dblib/unittests/t0022.c src/dblib/unittests/t0023.c
+	* src/dblib/unittests/text_buffer.c
+	* src/dblib/unittests/thread.c
+	* src/dblib/unittests/timeout.c
+	* win32/tds_sysdep_public.h
 	- begin making unittests work with Microsoft's library
 
 Sat Nov 15 10:56:48 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
@@ -976,4 +976,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2664 2008/11/18 01:16:49 jklowden Exp $
+$Id: ChangeLog,v 1.2665 2008/11/25 22:58:28 jklowden Exp $
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index 2810fcb..4e780a0 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -71,7 +71,7 @@ typedef struct _pbcb
 }
 TDS_PBCB;
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.172 2008/05/26 13:56:49 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.173 2008/11/25 22:58:28 jklowden Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
@@ -1400,6 +1400,12 @@ _bcp_read_hostfile(DBPROCESS * dbproc, FILE * hostfile, int *row_error)
 		 * At this point, however the field was read, however big it was, its address is coldata and its size is collen.
 		 */
 		tdsdump_log(TDS_DBG_FUNC, "Data read from hostfile: collen is now %d, data_is_null is %d\n", collen, data_is_null);
+		if (i == 370 - 1) {
+			char buf[32];
+			memset(buf, '\0', sizeof(buf));
+			memcpy(buf, coldata, collen);
+			tdsdump_log(TDS_DBG_FUNC, "column 370 is '%s', converts to %f\n", buf, atof(buf));
+		}
 		if (hostcol->tab_colnum) {
 			if (data_is_null) {
 				bcpcol->bcp_column_data->is_null = 1;
@@ -2024,6 +2030,8 @@ _bcp_exec_in(DBPROCESS * dbproc, DBINT * rows_copied)
 	
 					}
 				}
+			} else {
+				printf("skipping row %d (because <= %d)\n", dbproc->hostfileinfo->firstrow, row_of_hostfile);
 			}
 		}
 
diff --git a/src/dblib/unittests/bcp.c b/src/dblib/unittests/bcp.c
index 4e6b048..5954615 100644
--- a/src/dblib/unittests/bcp.c
+++ b/src/dblib/unittests/bcp.c
@@ -13,7 +13,7 @@
 
 #include "bcp.h"
 
-static char software_version[] = "$Id: bcp.c,v 1.14 2007/11/26 08:52:40 freddy77 Exp $";
+static char software_version[] = "$Id: bcp.c,v 1.15 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char cmd[512];
@@ -189,7 +189,7 @@ main(int argc, char **argv)
 
 	read_login_info(argc, argv);
 
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	dbinit();
diff --git a/src/dblib/unittests/common.c b/src/dblib/unittests/common.c
index 37961a0..1a7d5de 100644
--- a/src/dblib/unittests/common.c
+++ b/src/dblib/unittests/common.c
@@ -16,7 +16,7 @@
 #include "replacements.h"
 #endif
 
-static char software_version[] = "$Id: common.c,v 1.24 2008/09/09 14:48:03 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.25 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 typedef struct _tag_memcheck_t
@@ -154,7 +154,7 @@ read_login_info(int argc, char **argv)
 		in = fopen(filename, "r");
 		if (!in) {
 			fprintf(stderr, "Can not open %s file\n\n", filename);
-			return 1;
+			goto Override;
 		}
 	}
 
@@ -175,6 +175,7 @@ read_login_info(int argc, char **argv)
 	}
 	fclose(in);
 	
+	Override:
 	/* apply command-line overrides */
 	if (options.username) {
 		strcpy(USER, options.username);
@@ -192,6 +193,11 @@ read_login_info(int argc, char **argv)
 		strcpy(DATABASE, options.database);
 		free(options.database);
 	}
+
+	if (!*SERVER) {
+		fprintf(stderr, "no servername provided, quitting.\n");
+		exit(1);
+	}
 	
 	printf("found %s.%s for %s in \"%s\"\n", SERVER, DATABASE, USER, filename);
 	return 0;
@@ -326,7 +332,10 @@ syb_msg_handler(DBPROCESS * dbproc, DBINT msgno, int msgstate, int severity, cha
 		}
 	}
 
-	assert(0); /* no unanticipated messages allowed in unit tests */
+	if (severity) {
+		fprintf(stderr, "exit: no unanticipated messages allowed in unit tests\n");
+		exit(EXIT_FAILURE);
+	}
 	return 0;
 }
 
@@ -356,8 +365,8 @@ syb_err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *db
 	}
 
 	fprintf(stderr,
-		"DB-LIBRARY error (severity %d, dberr %d, oserr %d, dberrstr %s, oserrstr %s):\n",
-		severity, dberr, oserr, dberrstr ? dberrstr : "(null)", oserrstr ? oserrstr : "(null)");
+		"DB-LIBRARY error (dberr %d (severity %d): \"%s\"; oserr %d: \"%s\")\n",
+		dberr, severity, dberrstr ? dberrstr : "(null)", oserr, oserrstr ? oserrstr : "(null)");
 	fflush(stderr);
 
 	/*
@@ -373,6 +382,10 @@ syb_err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *db
 		}
 	}
 
-	assert(0); /* no unanticipated errors allowed in unit tests */
+	if (severity) {
+		fprintf(stderr, "error: no unanticipated errors allowed in unit tests\n");
+		exit(EXIT_FAILURE);
+	}
+
 	return INT_CANCEL;
 }
diff --git a/src/dblib/unittests/common.h b/src/dblib/unittests/common.h
index 35d57a8..67b72db 100644
--- a/src/dblib/unittests/common.h
+++ b/src/dblib/unittests/common.h
@@ -2,7 +2,7 @@
 #ifndef COMMON_h
 #define COMMON_h
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.14 2007/12/20 21:57:35 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.15 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #if HAVE_CONFIG_H
@@ -28,6 +28,15 @@ static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_wa
 #include <sqlfront.h>
 #include <sqldb.h>
 
+#if !defined(FREETDS_SRCDIR)
+#define FREETDS_SRCDIR "../../../.."
+#endif
+
+#if !defined(EXIT_FAILURE)
+#define EXIT_FAILURE 1
+#define EXIT_SUCCESS 0
+#endif
+
 #ifdef DBNTWIN32
 /*
  * Define Sybase's symbols in terms of Microsoft's. 
diff --git a/src/dblib/unittests/dbmorecmds.c b/src/dblib/unittests/dbmorecmds.c
index fbc0bd7..c5b76f2 100644
--- a/src/dblib/unittests/dbmorecmds.c
+++ b/src/dblib/unittests/dbmorecmds.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: dbmorecmds.c,v 1.12 2006/07/06 12:48:16 freddy77 Exp $";
+static char software_version[] = "$Id: dbmorecmds.c,v 1.13 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version,	no_unused_var_warn };
 
 int failed = 0;
@@ -22,7 +22,7 @@ main(int argc, char **argv)
 	set_malloc_options();
 
 	read_login_info(argc, argv);
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	/* Fortify_EnterScope(); */
diff --git a/src/dblib/unittests/hang.c b/src/dblib/unittests/hang.c
index 4d9606d..7b3c750 100644
--- a/src/dblib/unittests/hang.c
+++ b/src/dblib/unittests/hang.c
@@ -37,9 +37,11 @@
 #include <sys/wait.h>
 #endif /* HAVE_SYS_WAIT_H */
 
-static char software_version[] = "$Id: hang.c,v 1.2 2007/06/04 12:15:57 freddy77 Exp $";
+static char software_version[] = "$Id: hang.c,v 1.3 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
+char *UNITTEST;
+
 #if HAVE_FSTAT && defined(S_IFSOCK)
 
 static int end_socket = -1;
@@ -82,7 +84,7 @@ test(int close_socket)
 	RETCODE ret;
 	int expected_error = -1;
 
-	printf("Start\n");
+	printf("Starting %s\n", UNITTEST);
 
 	dbinit();
 
@@ -141,6 +143,7 @@ test(int close_socket)
 int
 main(int argc, char **argv)
 {
+	UNITTEST = argv[0];
 	read_login_info(argc, argv);
 	if (test(0) || test(1))
 		return 1;
diff --git a/src/dblib/unittests/null.c b/src/dblib/unittests/null.c
index 3faf382..7563bec 100644
--- a/src/dblib/unittests/null.c
+++ b/src/dblib/unittests/null.c
@@ -7,7 +7,7 @@
 
 #include <unistd.h>
 
-static char software_version[] = "$Id: null.c,v 1.6 2007/12/14 10:23:38 freddy77 Exp $";
+static char software_version[] = "$Id: null.c,v 1.7 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static DBPROCESS *dbproc = NULL;
@@ -140,7 +140,7 @@ main(int argc, char **argv)
 
 	read_login_info(argc, argv);
 
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 
 	dbinit();
 
diff --git a/src/dblib/unittests/null2.c b/src/dblib/unittests/null2.c
index 30e4849..b3b43f0 100644
--- a/src/dblib/unittests/null2.c
+++ b/src/dblib/unittests/null2.c
@@ -6,7 +6,7 @@
 
 #include <unistd.h>
 
-static char software_version[] = "$Id: null2.c,v 1.4 2007/12/14 10:23:38 freddy77 Exp $";
+static char software_version[] = "$Id: null2.c,v 1.5 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static DBPROCESS *dbproc = NULL;
@@ -152,7 +152,7 @@ main(int argc, char **argv)
 
 	read_login_info(argc, argv);
 
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 
 	dbinit();
 
diff --git a/src/dblib/unittests/rpc.c b/src/dblib/unittests/rpc.c
index af41df7..bd14096 100644
--- a/src/dblib/unittests/rpc.c
+++ b/src/dblib/unittests/rpc.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: rpc.c,v 1.34 2008/07/15 09:53:01 freddy77 Exp $";
+static char software_version[] = "$Id: rpc.c,v 1.35 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char cmd[4096];
@@ -167,7 +167,7 @@ main(int argc, char **argv)
 
 	read_login_info(argc, argv);
 
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	dbinit();
diff --git a/src/dblib/unittests/setnull.c b/src/dblib/unittests/setnull.c
index 6da7092..c472667 100644
--- a/src/dblib/unittests/setnull.c
+++ b/src/dblib/unittests/setnull.c
@@ -5,7 +5,7 @@
 #include "common.h"
 #include "replacements.h"
 
-static char software_version[] = "$Id: setnull.c,v 1.8 2007/12/20 21:57:35 freddy77 Exp $";
+static char software_version[] = "$Id: setnull.c,v 1.9 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int failed = 0;
@@ -76,7 +76,7 @@ main(int argc, char **argv)
 	
 	read_login_info(argc, argv);
 
-	printf("Start\n");
+	printf("Starting %s\n", argv[0]);
 	dbinit();
 
 	dberrhandle(syb_err_handler);
diff --git a/src/dblib/unittests/t0001.c b/src/dblib/unittests/t0001.c
index b1c8db3..9d592b5 100644
--- a/src/dblib/unittests/t0001.c
+++ b/src/dblib/unittests/t0001.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0001.c,v 1.26 2007/12/04 02:06:38 jklowden Exp $";
+static char software_version[] = "$Id: t0001.c,v 1.27 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -26,10 +26,12 @@ main(int argc, char **argv)
 	set_malloc_options();
 
 	read_login_info(argc, argv);
-	argc -= optind;
-	argv += optind;
+	if (argc > 1) {
+		argc -= optind;
+		argv += optind;
+	}
 
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	/* Fortify_EnterScope(); */
diff --git a/src/dblib/unittests/t0002.c b/src/dblib/unittests/t0002.c
index 6b80a1a..e5a3474 100644
--- a/src/dblib/unittests/t0002.c
+++ b/src/dblib/unittests/t0002.c
@@ -10,7 +10,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: t0002.c,v 1.21 2007/12/04 02:06:38 jklowden Exp $";
+static char software_version[] = "$Id: t0002.c,v 1.22 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int failed = 0;
@@ -57,7 +57,7 @@ main(int argc, char **argv)
 
 	read_login_info(argc, argv);
 
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	/* Fortify_EnterScope(); */
diff --git a/src/dblib/unittests/t0003.c b/src/dblib/unittests/t0003.c
index 5acb059..98b444d 100644
--- a/src/dblib/unittests/t0003.c
+++ b/src/dblib/unittests/t0003.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0003.c,v 1.13 2007/12/04 02:06:38 jklowden Exp $";
+static char software_version[] = "$Id: t0003.c,v 1.14 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -28,7 +28,7 @@ main(int argc, char **argv)
 
 	read_login_info(argc, argv);
 
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	/* Fortify_EnterScope(); */
diff --git a/src/dblib/unittests/t0004.c b/src/dblib/unittests/t0004.c
index 33f95cb..ea06e9e 100644
--- a/src/dblib/unittests/t0004.c
+++ b/src/dblib/unittests/t0004.c
@@ -6,7 +6,7 @@
 #include "common.h"
 
 
-static char software_version[] = "$Id: t0004.c,v 1.16 2007/12/04 02:06:38 jklowden Exp $";
+static char software_version[] = "$Id: t0004.c,v 1.17 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -27,7 +27,7 @@ main(int argc, char **argv)
 
 	read_login_info(argc, argv);
 
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	dbinit();
diff --git a/src/dblib/unittests/t0005.c b/src/dblib/unittests/t0005.c
index c5d9d1a..8c24410 100644
--- a/src/dblib/unittests/t0005.c
+++ b/src/dblib/unittests/t0005.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0005.c,v 1.23 2008/11/12 00:47:31 jklowden Exp $";
+static char software_version[] = "$Id: t0005.c,v 1.24 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -24,7 +24,7 @@ main(int argc, char **argv)
 	set_malloc_options();
 
 	read_login_info(argc, argv);
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 
diff --git a/src/dblib/unittests/t0006.c b/src/dblib/unittests/t0006.c
index ed62817..019c177 100644
--- a/src/dblib/unittests/t0006.c
+++ b/src/dblib/unittests/t0006.c
@@ -6,7 +6,7 @@
 #include "common.h"
 
 
-static char software_version[] = "$Id: t0006.c,v 1.16 2007/12/04 02:06:38 jklowden Exp $";
+static char software_version[] = "$Id: t0006.c,v 1.17 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -54,7 +54,7 @@ main(int argc, char **argv)
 	set_malloc_options();
 
 	read_login_info(argc, argv);
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	/* Fortify_EnterScope(); */
diff --git a/src/dblib/unittests/t0007.c b/src/dblib/unittests/t0007.c
index 6061a3b..f82cc7e 100644
--- a/src/dblib/unittests/t0007.c
+++ b/src/dblib/unittests/t0007.c
@@ -6,7 +6,7 @@
 #include "common.h"
 
 
-static char software_version[] = "$Id: t0007.c,v 1.17 2007/12/04 02:06:38 jklowden Exp $";
+static char software_version[] = "$Id: t0007.c,v 1.18 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -81,7 +81,7 @@ main(int argc, char **argv)
 
 	read_login_info(argc, argv);
 
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	dbinit();
diff --git a/src/dblib/unittests/t0008.c b/src/dblib/unittests/t0008.c
index d212e69..d81caab 100644
--- a/src/dblib/unittests/t0008.c
+++ b/src/dblib/unittests/t0008.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0008.c,v 1.16 2007/12/04 02:06:38 jklowden Exp $";
+static char software_version[] = "$Id: t0008.c,v 1.17 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -25,7 +25,7 @@ main(int argc, char **argv)
 
 	read_login_info(argc, argv);
 
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	/* Fortify_EnterScope(); */
diff --git a/src/dblib/unittests/t0009.c b/src/dblib/unittests/t0009.c
index e96531d..22f1cd4 100644
--- a/src/dblib/unittests/t0009.c
+++ b/src/dblib/unittests/t0009.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0009.c,v 1.14 2006/07/06 12:48:16 freddy77 Exp $";
+static char software_version[] = "$Id: t0009.c,v 1.15 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -23,7 +23,7 @@ main(int argc, char **argv)
 
 	read_login_info(argc, argv);
 
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	/* Fortify_EnterScope(); */
diff --git a/src/dblib/unittests/t0011.c b/src/dblib/unittests/t0011.c
index 3b31edb..7d0996a 100644
--- a/src/dblib/unittests/t0011.c
+++ b/src/dblib/unittests/t0011.c
@@ -6,7 +6,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0011.c,v 1.12 2007/12/04 02:06:38 jklowden Exp $";
+static char software_version[] = "$Id: t0011.c,v 1.13 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int failed = 0;
@@ -24,7 +24,7 @@ main(int argc, char **argv)
 	char cmd[2048];
 
 	read_login_info(argc, argv);
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 
 	dbinit();
 
diff --git a/src/dblib/unittests/t0012.c b/src/dblib/unittests/t0012.c
index be5c34b..3fe88fa 100644
--- a/src/dblib/unittests/t0012.c
+++ b/src/dblib/unittests/t0012.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0012.c,v 1.21 2007/01/15 02:00:58 jklowden Exp $";
+static char software_version[] = "$Id: t0012.c,v 1.22 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 int failed = 0;
 
@@ -24,7 +24,7 @@ main(int argc, char *argv[])
 	set_malloc_options();
 
 	read_login_info(argc, argv);
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	dbinit();
 
 	dberrhandle(syb_err_handler);
diff --git a/src/dblib/unittests/t0013.c b/src/dblib/unittests/t0013.c
index 081bdb7..ba4fbc2 100644
--- a/src/dblib/unittests/t0013.c
+++ b/src/dblib/unittests/t0013.c
@@ -5,26 +5,52 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0013.c,v 1.24 2008/11/12 10:38:15 freddy77 Exp $";
+static char software_version[] = "$Id: t0013.c,v 1.25 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define BLOB_BLOCK_SIZE 4096
 
 int failed = 0;
 
+#if !defined(FREETDS_SRCDIR)
+#define FREETDS_SRCDIR "../../../.."
+#endif
+
+#define TABLE_NAME "freetds_dblib_t0013"
+
 char *testargs[] = { "", FREETDS_SRCDIR "/data.bin", "t0013.out" };
 
+DBPROCESS *dbproc, *dbprocw;
+
+void
+drop_table(void)
+{
+	char cmd[1024];
+
+	if (!dbproc) 
+		return;
+
+	dbcancel(dbproc);
+
+	sprintf(cmd, "drop table " TABLE_NAME);
+	fprintf(stdout, "sql: %s\n", cmd);
+	dbcmd(dbproc, cmd);
+	dbsqlexec(dbproc);
+	while (dbresults(dbproc) != NO_MORE_RESULTS) {
+		/* nop */
+	}
+}
+
 int
 main(int argc, char **argv)
 {
 	LOGINREC *login;
-	DBPROCESS *dbproc;
 	int i;
 	DBINT testint;
 	FILE *fp;
 	long result, isiz;
 	char *blob, *rblob;
-	unsigned char *textPtr = NULL, *timeStamp = NULL;
+	DBBINARY *textPtr = NULL, *timeStamp = NULL;
 	char objname[256];
 	char sqlCmd[256];
 	char rbuf[BLOB_BLOCK_SIZE];
@@ -32,11 +58,13 @@ main(int argc, char **argv)
 	BOOL readFirstImage;
 	char cmd[1024];
 	int data_ok;
-
+#ifdef DBWRITE_OK_FOR_OVER_4K
+	int numtowrite, numwritten;
+#endif
 	set_malloc_options();
 
 	read_login_info(argc, argv);
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	dbinit();
 
 	dberrhandle(syb_err_handler);
@@ -52,13 +80,13 @@ main(int argc, char **argv)
 	fprintf(stdout, "About to open, PASSWORD: %s, USER: %s, SERVER: %s\n", "", "", "");	/* PASSWORD, USER, SERVER); */
 
 	dbproc = dbopen(login, SERVER);
+	dbprocw = dbopen(login, SERVER);
 	if (strlen(DATABASE)) {
 		dbuse(dbproc, DATABASE);
+		dbuse(dbprocw, DATABASE);
 	}
-	dbloginfree(login);
-	fprintf(stdout, "After logon\n");
-
-	fprintf(stdout, "About to read binary input file\n");
+	// dbloginfree(login);
+	fprintf(stdout, "logged in\n");
 
 	if (argc == 1) {
 		argv = testargs;
@@ -73,33 +101,37 @@ main(int argc, char **argv)
 		fprintf(stderr, "Cannot open input file: %s\n", argv[1]);
 		return 2;
 	}
+	fprintf(stdout, "Reading binary input file\n");
+
 	fseek(fp, 0, SEEK_END);
 	isiz = ftell(fp);
 	fseek(fp, 0, SEEK_SET);
 
-	blob = (char *) malloc(isiz);
+	blob = malloc(isiz);
+	assert(blob);
 	fread((void *) blob, isiz, 1, fp);
 	fclose(fp);
 
-	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0013 (i int not null, PigTure image not null)");
+	sprintf(cmd, "create table " TABLE_NAME " (i int not null, PigTure image not null)");
+	fprintf(stdout, "sql: %s\n", cmd);
+	dbcmd(dbproc, cmd);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
 	}
 
+	atexit(drop_table);
 
-	fprintf(stdout, "insert\n");
-
-	sprintf(cmd, "insert into #dblib0013 values (1, '')");
-	fprintf(stdout, "%s\n", cmd);
+	sprintf(cmd, "insert into " TABLE_NAME " values (1, '')");
+	fprintf(stdout, "sql: %s\n", cmd);
 	dbcmd(dbproc, cmd);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
 	}
 
-	sprintf(sqlCmd, "SELECT PigTure FROM #dblib0013 WHERE i = 1");
+	sprintf(sqlCmd, "SELECT PigTure FROM " TABLE_NAME " WHERE i = 1");
+	fprintf(stdout, "sql: %s\n", sqlCmd);
 	dbcmd(dbproc, sqlCmd);
 	dbsqlexec(dbproc);
 	if (dbresults(dbproc) != SUCCEED) {
@@ -107,40 +139,69 @@ main(int argc, char **argv)
 		return 4;
 	}
 
-	while ((result = dbnextrow(dbproc)) != NO_MORE_ROWS) {
-		strcpy(objname, "#dblib0013.PigTure");
+	for (i=0; (result = dbnextrow(dbproc)) != NO_MORE_ROWS; i++) {
+		assert(REG_ROW == result);
+		printf("fetching row %d\n", i+1);
+		strcpy(objname, TABLE_NAME ".PigTure");
 		textPtr = dbtxptr(dbproc, 1);
 		timeStamp = dbtxtimestamp(dbproc, 1);
+		break; /* can't proceed until no more rows */
 	}
+	assert(REG_ROW == result || 0 < i);
+	assert(0 < textPtr);
 
 	/*
 	 * Use #ifdef if you want to test dbmoretext mode (needed for 16-bit apps)
 	 * Use #ifndef for big buffer version (32-bit)
 	 */
+	fprintf(stdout, "writing text ... ");
 #ifndef DBWRITE_OK_FOR_OVER_4K
-	if (dbwritetext(dbproc, objname, textPtr, DBTXPLEN, timeStamp, FALSE, isiz, (BYTE*) blob) != SUCCEED)
+	if (dbwritetext(dbprocw, objname, textPtr, DBTXPLEN, timeStamp, FALSE, isiz, (BYTE*) blob) != SUCCEED)
 		return 5;
+	fprintf(stdout, "done (in one shot)\n");
+	for (; (result = dbnextrow(dbproc)) != NO_MORE_ROWS; i++) {
+		assert(REG_ROW == result);
+		printf("fetching row %d?\n", i+1);
+	}
 #else
-	if (dbwritetext(dbproc, objname, textPtr, DBTXPLEN, timeStamp, FALSE, isiz, NULL) != SUCCEED)
+	if (dbwritetext(dbprocw, objname, textPtr, DBTXPLEN, timeStamp, FALSE, isiz, NULL) != SUCCEED)
 		return 15;
-	dbsqlok(dbproc);
-	dbresults(dbproc);
+	fprintf(stdout, "done\n");
+
+	fprintf(stdout, "dbsqlok\n");
+	dbsqlok(dbprocw);
+	fprintf(stdout, "dbresults\n");
+	dbresults(dbprocw);
 
 	numtowrite = 0;
 	/* Send the update value in chunks. */
 	for (numwritten = 0; numwritten < isiz; numwritten += numtowrite) {
+		fprintf(stdout, "dbmoretext %d\n", 1 + numwritten);
 		numtowrite = (isiz - numwritten);
 		if (numtowrite > BLOB_BLOCK_SIZE)
 			numtowrite = BLOB_BLOCK_SIZE;
-		dbmoretext(dbproc, (DBINT) numtowrite, blob + numwritten);
+		dbmoretext(dbprocw, (DBINT) numtowrite, blob + numwritten);
+	}
+	dbsqlok(dbprocw);
+	while (dbresults(dbprocw) != NO_MORE_RESULTS){
+		printf("suprise!\n");
 	}
-	dbsqlok(dbproc);
-	while (dbresults(dbproc) != NO_MORE_RESULTS);
 #endif
+#if 0
+	if (SUCCEED != dbclose(dbproc)){
+		fprintf(stdout, "dbclose failed");
+		exit(1);
+	}
+	dbproc = dbopen(login, SERVER);
+	assert(dbproc);
+	if (strlen(DATABASE)) {
+		dbuse(dbproc, DATABASE);
+	}
+#endif
+	sprintf(cmd, "select i, PigTure from " TABLE_NAME " order by i");
 
-	fprintf(stdout, "select\n");
-
-	dbcmd(dbproc, "select * from #dblib0013 order by i");
+	fprintf(stdout, "sql: %s\n", cmd);
+	dbcmd(dbproc, cmd);
 	dbsqlexec(dbproc);
 
 	if (dbresults(dbproc) != SUCCEED) {
@@ -150,36 +211,41 @@ main(int argc, char **argv)
 	}
 
 	for (i = 1; i <= dbnumcols(dbproc); i++) {
-		printf("col %d is %s\n", i, dbcolname(dbproc, i));
+		printf("col %d, \"%s\", is type %s\n", 
+			i, dbcolname(dbproc, i), dbprtype(dbcoltype(dbproc, i)));
+	}
+	if (2 != dbnumcols(dbproc)) {
+		fprintf(stderr, "Failed.  Expected 2 columns\n");
+		exit(1);
 	}
 
 	if (SUCCEED != dbbind(dbproc, 1, INTBIND, -1, (BYTE *) & testint)) {
-		failed = 1;
 		fprintf(stderr, "Had problem with bind\n");
-		abort();
+		exit(1);
 	}
 
 	if (REG_ROW != dbnextrow(dbproc)) {
-		failed = 1;
 		fprintf(stderr, "Failed.  Expected a row\n");
 		exit(1);
 	}
 	if (testint != 1) {
 		failed = 1;
-		fprintf(stderr, "Failed.  Expected i to be %d, was %d\n", i, (int) testint);
-		abort();
+		fprintf(stderr, "Failed.  Expected i to be %d, was %d\n", 1, (int) testint);
+		exit(1);
 	}
 	dbnextrow(dbproc);
 
 	/* get the image */
 	strcpy(sqlCmd, "SET TEXTSIZE 2147483647");
+	fprintf(stdout, "sql: %s\n", sqlCmd);
 	dbcmd(dbproc, sqlCmd);
 	dbsqlexec(dbproc);
 	dbresults(dbproc);
 
 	fprintf(stdout, "select 2\n");
 
-	sprintf(sqlCmd, "SELECT PigTure FROM #dblib0013 WHERE i = 1");
+	sprintf(sqlCmd, "SELECT PigTure FROM " TABLE_NAME " WHERE i = 1");
+	fprintf(stdout, "sql: %s\n", sqlCmd);
 	dbcmd(dbproc, sqlCmd);
 	dbsqlexec(dbproc);
 	if (dbresults(dbproc) != SUCCEED) {
@@ -224,6 +290,17 @@ main(int argc, char **argv)
 	}
 
 	free(blob);
+	drop_table();
+#if 1
+	dbclose(dbproc);
+#else
+	if (SUCCEED != dbclose(dbproc)){
+		fprintf(stdout, "dbclose failed");
+		abort();
+	}
+#endif
+	dbproc = 0;
+
 	dbexit();
 
 	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
diff --git a/src/dblib/unittests/t0014.c b/src/dblib/unittests/t0014.c
index d88dcd7..96ca83e 100644
--- a/src/dblib/unittests/t0014.c
+++ b/src/dblib/unittests/t0014.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0014.c,v 1.27 2006/07/06 12:48:16 freddy77 Exp $";
+static char software_version[] = "$Id: t0014.c,v 1.28 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define BLOB_BLOCK_SIZE 4096
@@ -36,7 +36,7 @@ main(int argc, char **argv)
 	set_malloc_options();
 
 	read_login_info(argc, argv);
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	dbinit();
 
 	dberrhandle(syb_err_handler);
diff --git a/src/dblib/unittests/t0015.c b/src/dblib/unittests/t0015.c
index 02ea29c..ba8a3b8 100644
--- a/src/dblib/unittests/t0015.c
+++ b/src/dblib/unittests/t0015.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0015.c,v 1.17 2007/12/04 02:06:38 jklowden Exp $";
+static char software_version[] = "$Id: t0015.c,v 1.18 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -26,7 +26,7 @@ main(int argc, char **argv)
 	set_malloc_options();
 
 	read_login_info(argc, argv);
-	fprintf(stdout, "Start\n");
+	fprintf(stdout, "Starting %s\n", argv[0]);
 	add_bread_crumb();
 
 	/* Fortify_EnterScope(); */
diff --git a/src/dblib/unittests/t0016.c b/src/dblib/unittests/t0016.c
index 9abc89d..5c966bd 100644
--- a/src/dblib/unittests/t0016.c
+++ b/src/dblib/unittests/t0016.c
@@ -4,8 +4,9 @@
  */
 
 #include "common.h"
+#include <sys/stat.h>
 
-static char software_version[] = "$Id: t0016.c,v 1.26 2006/12/26 14:56:19 freddy77 Exp $";
+static char software_version[] = "$Id: t0016.c,v 1.27 2008/11/25 22:58:29 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int failed = 0;
@@ -22,6 +23,9 @@ failure(const char *fmt, ...)
         va_end(ap);
 }
 
+#define INFILE_NAME "t0016.in"
+#define TABLE_NAME "#dblib0016"
+
 int
 main(int argc, char *argv[])
 {
@@ -31,20 +35,32 @@ main(int argc, char *argv[])
 	char sqlCmd[256];
 	RETCODE ret;
 	const char *out_file = "t0016.out";
-	const char *in_file = FREETDS_SRCDIR "/t0016.in";
+	const char *in_file = FREETDS_SRCDIR "/" INFILE_NAME;
 	const char *err_file = "t0016.err";
 	DBINT rows_copied;
 	int num_cols = 0;
 
 	FILE *input_file, *output_file;
 
+#if 1
+	struct stat sb;
+
+	if (0 != stat(in_file, &sb)) {
+		in_file = INFILE_NAME;
+		if (0 != stat(in_file, &sb)) {
+			perror("could not open " INFILE_NAME);
+			exit(1);
+		}
+	}
+#endif
+
 	setbuf(stdout, NULL);
 	setbuf(stderr, NULL);
 
 	set_malloc_options();
 
 	read_login_info(argc, argv);
-	printf("Start\n");
+	printf("Starting %s\n", argv[0]);
 	dbinit();
 
 	dberrhandle(syb_err_handler);
@@ -65,7 +81,7 @@ main(int argc, char *argv[])
 	dbloginfree(login);
 	printf("After logon\n");
 
-	printf("Creating table\n");
+	printf("Creating table '%s'\n", TABLE_NAME);
 	strcpy(sqlCmd, "create table #dblib0016 (f1 int not null, s1 int null, f2 numeric(10,2) null, ");
 	strcat(sqlCmd, "f3 varchar(255) not null, f4 datetime null) ");
 	dbcmd(dbproc, sqlCmd);
@@ -76,7 +92,8 @@ main(int argc, char *argv[])
 
 	/* BCP in */
 
-	ret = bcp_init(dbproc, "#dblib0016", in_file, err_file, DB_IN);
+	printf("bcp_init with in_file as '%s'\n", in_file);
+	ret = bcp_init(dbproc, TABLE_NAME, in_file, err_file, DB_IN);
 	if (ret != SUCCEED)
 		failure("bcp_init failed\n");
 
@@ -119,7 +136,7 @@ main(int argc, char *argv[])
 	/* BCP out */
 
 	rows_copied = 0;
-	ret = bcp_init(dbproc, "#dblib0016", out_file, err_file, DB_OUT);
+	ret = bcp_init(dbproc, TABLE_NAME, out_file, err_file, DB_OUT);
 	if (ret != SUCCEED)
 		failure("bcp_int failed\n");
 
